from ase.atoms import Atom
from ase.atoms import Atoms as ASEAtoms
import numpy as np
from ase.visualize import view
from ase.constraints import Hookean

from CalcTroll.ASEUtils.Atoms import Atoms
from CalcTroll.ASEUtils.Atoms import DopingTag
from CalcTroll.ASEUtils.AtomUtilities import removeCopies, orderAtoms
from CalcTroll.Plugins.Systems.Molecule import Molecule

from CalcTroll import API
from CalcTroll.API import DEFAULT

from .PolyaromaticHydroCarbon import PolyaromaticHydroCarbon, passivate_atoms
from .ConjugatedMolecules import triplicateEndGroup

def hexagonateEndGroup(group):
    atoms = group.copy()
    for i in range(5):
        group.rotate(v=(0,0,1), a=60)
        atoms += group.copy()

    return atoms

class NanographenePrecursor(Molecule):
    def __init__(self, name=DEFAULT, parameters=DEFAULT):
        molecule = PolyaromaticHydroCarbon(
           indices=[(1,  0),
                    (2,  1), (3,  1),
                    (1, -1), (2, -1),
                    ],
            folds=[(2, 1, 30), (4, 3, -30)],
            passivate=False,
        )
        atoms = molecule.atoms()
        atoms.rotate('x', 15)
        atoms = triplicateEndGroup(atoms)
        atoms = molecule.passivate(atoms)
        atoms.rotate((0, 0, 1), 30.)
        Molecule.__init__(self, atoms, name=name, parameters=parameters)


class Nanographene(Molecule):
    def __init__(self, name=DEFAULT, parameters=DEFAULT):
        molecule = PolyaromaticHydroCarbon(
           indices=[(1,  0), (2,  0),
                    (2,  1), (3,  1),
                    (1, -1), (2, -1),
                    ],
            passivate=False,
        )
        atoms = molecule.atoms()
        atoms = triplicateEndGroup(atoms)
        atoms = molecule.passivate(atoms)
        atoms.rotate((0, 0, 1), 30.)
        Molecule.__init__(self, atoms, name=name, parameters=parameters)


class MethylNanographene(Molecule):
    def __init__(self, name=DEFAULT, parameters=DEFAULT):
        molecule = Nanographene()
        atoms = molecule.atoms()
        del atoms.constraints
        h_take = np.array([s=='H' for s in atoms.get_chemical_symbols()])
        h_atoms = atoms[h_take]
        atoms = atoms[np.logical_not(h_take)]

        h_atoms1 = h_atoms
        h_atoms2 = h_atoms.copy()
        h_atoms1.positions[:, 2] += 0.6
        h_atoms2.positions[:, 2] -= 0.6

        atoms += h_atoms1
        atoms += h_atoms2

        Molecule.__init__(self, atoms, name=name, parameters=parameters)


class NitrogenNanographene(Molecule):
    def __init__(self, **kwargs):
        length = 1.4
        atoms = ASEAtoms([
            Atom('C', ( 0.0, length ,0.0,)),
            Atom('N', ( 0.0, length*2 ,0.0,)),
            Atom('C', (  length*np.sqrt(3)/2, length*2.5 , 0.0)),
            Atom('C', ( -length*np.sqrt(3)/2, length*2.5 , 0.0)),
            Atom('C', (  length/2, length*3.5 , 0.0)),
            Atom('C', ( -length/2, length*3.5 , 0.0)),
            ]
            )
        atoms = hexagonateEndGroup(atoms)
        atoms = passivate_atoms(atoms)
        atoms.rotate(v=(0,0,1), a=30)
        Molecule.__init__(self, atoms, **kwargs)

class DimerNitrogenNanographene(Molecule):
    def __init__(self, name=DEFAULT, potential_strength=1.0):
        length = 1.4
        atoms = ASEAtoms([
            Atom('C', ( 0.0, length ,0.0,)),
            Atom('N', ( 0.0, length*2 ,0.0,)),
            Atom('C', (  length*np.sqrt(3)/2, length*2.5 , 0.0)),
            Atom('C', ( -length*np.sqrt(3)/2, length*2.5 , 0.0)),
            Atom('C', (  length/2, length*3.5 , 0.0)),
            Atom('C', ( -length/2, length*3.5 , 0.0)),
            ]
            )
        atoms = hexagonateEndGroup(atoms)
        atoms.cell = np.array([20, 20, 20])
        atoms = orderAtoms(atoms, (0, 1, 2))
        maxi = atoms.positions[:, 0].max()
        second_group = atoms.copy()
        second_group.translate([2*maxi + length, 0, 0])
        atoms += second_group
        atoms = passivate_atoms(atoms)
        atoms.translate(-atoms.positions.mean(axis=0))
        atoms.rattle(0.1)
        Molecule.__init__(self, atoms, name=name, potential_strength=potential_strength)

class SurfaceRelaxedDimerNitrogenNanographene(Molecule):
    def __init__(self, name=DEFAULT, potential_strength=1.0):
        atoms = ASEAtoms([
                Atom('C',     (  1.78935037  ,   -9.80315066  ,    2.49395519)),
                Atom('C',     ( -1.76691621  ,   -9.80428276  ,    2.50042558)),
                Atom('C',     (  3.01890553  ,   -9.08874559  ,    2.43052833)),
                Atom('C',     ( -2.99617225  ,   -9.09043133  ,    2.44316123)),
                Atom('C',     (  0.74345910  ,   -8.89050181  ,    2.80482421)),
                Atom('C',     ( -0.71848700  ,   -8.88994212  ,    2.80356007)),
                Atom('C',     (  2.75629971  ,   -7.71182760  ,    2.72898150)),
                Atom('N',     (  1.38428721  ,   -7.66160309  ,    2.98540634)),
                Atom('N',     ( -1.35905145  ,   -7.66159186  ,    2.98649651)),
                Atom('C',     ( -2.73250250  ,   -7.71243693  ,    2.73624720)),
                Atom('C',     (  3.48495310  ,   -6.44917498  ,    2.73263781)),
                Atom('C',     (  0.70727394  ,   -6.48762686  ,    3.18372625)),
                Atom('C',     ( -0.68192146  ,   -6.48764499  ,    3.18396441)),
                Atom('C',     ( -3.46116043  ,   -6.44990767  ,    2.73868278)),
                Atom('C',     (  4.79930566  ,   -5.98798548  ,    2.42930232)),
                Atom('C',     ( -4.77653737  ,   -5.98844820  ,    2.43744562)),
                Atom('N',     (  2.74535904  ,   -5.28208381  ,    2.96262896)),
                Atom('C',     (  1.39710886  ,   -5.27956958  ,    3.16748137)),
                Atom('C',     ( -1.37202172  ,   -5.27984984  ,    3.16819045)),
                Atom('N',     ( -2.72090266  ,   -5.28229402  ,    2.96555916)),
                Atom('C',     (  4.79822598  ,   -4.56734948  ,    2.42772577)),
                Atom('C',     ( -4.77560772  ,   -4.56801295  ,    2.43686799)),
                Atom('C',     (  3.48523096  ,   -4.11505985  ,    2.74171426)),
                Atom('C',     (  0.70514978  ,   -4.07183074  ,    3.15730426)),
                Atom('C',     ( -0.68023608  ,   -4.07211853  ,    3.15701276)),
                Atom('C',     ( -3.46174422  ,   -4.11558365  ,    2.74810346)),
                Atom('C',     (  2.75232343  ,   -2.85224117  ,    2.75233096)),
                Atom('N',     (  1.37436272  ,   -2.89278285  ,    2.97838887)),
                Atom('N',     ( -1.35036735  ,   -2.89335693  ,    2.97919167)),
                Atom('C',     ( -2.72941332  ,   -2.85234341  ,    2.75992280)),
                Atom('C',     (  0.74026946  ,   -1.65014120  ,    2.85272308)),
                Atom('C',     ( -0.71689509  ,   -1.65001835  ,    2.85565276)),
                Atom('C',     (  3.04354983  ,   -1.48322618  ,    2.54379012)),
                Atom('C',     ( -3.02176713  ,   -1.48281165  ,    2.55829899)),
                Atom('C',     (  1.83036626  ,   -0.71940193  ,    2.63596674)),
                Atom('C',     ( -1.80832258  ,   -0.71880180  ,    2.64736782)),
                Atom('C',     (  1.82937303  ,    0.73275809  ,    2.63424981)),
                Atom('C',     ( -1.80860990  ,    0.73350204  ,    2.65497732)),
                Atom('C',     (  3.04076137  ,    1.49768987  ,    2.53435194)),
                Atom('C',     ( -3.02148354  ,    1.49857515  ,    2.57617040)),
                Atom('C',     (  0.73962286  ,    1.66279597  ,    2.85790121)),
                Atom('C',     ( -0.71664582  ,    1.66267269  ,    2.87057655)),
                Atom('C',     (  2.74946465  ,    2.86632363  ,    2.74629806)),
                Atom('N',     (  1.37270698  ,    2.90619166  ,    2.97947431)),
                Atom('N',     ( -1.34984736  ,    2.90439582  ,    3.01226442)),
                Atom('C',     ( -2.72840178  ,    2.86558224  ,    2.79462383)),
                Atom('C',     (  3.48168938  ,    4.12856654  ,    2.74081349)),
                Atom('C',     (  0.70518216  ,    4.08219822  ,    3.18195993)),
                Atom('C',     ( -0.68007427  ,    4.08161545  ,    3.20327301)),
                Atom('C',     ( -3.45917969  ,    4.12852180  ,    2.79590312)),
                Atom('C',     (  4.79327265  ,    4.58403610  ,    2.42398536)),
                Atom('C',     ( -4.76437051  ,    4.58395134  ,    2.45467460)),
                Atom('N',     (  2.74372645  ,    5.29256737  ,    2.98033250)),
                Atom('C',     (  1.39770352  ,    5.28899642  ,    3.20159498)),
                Atom('C',     ( -1.37247390  ,    5.28869741  ,    3.24425534)),
                Atom('N',     ( -2.72432057  ,    5.29257778  ,    3.05135966)),
                Atom('C',     (  4.79520031  ,    6.00424998  ,    2.44553414)),
                Atom('C',     ( -4.76571983  ,    6.00423112  ,    2.47263962)),
                Atom('C',     (  3.48352714  ,    6.46234707  ,    2.76759872)),
                Atom('C',     (  0.70879642  ,    6.49679885  ,    3.24695500)),
                Atom('C',     ( -0.68079373  ,    6.49662590  ,    3.26532472)),
                Atom('C',     ( -3.45971164  ,    6.46177629  ,    2.81714571)),
                Atom('C',     (  2.75647498  ,    7.72548187  ,    2.79296311)),
                Atom('N',     (  1.38574614  ,    7.67360627  ,    3.06058008)),
                Atom('N',     ( -1.35865131  ,    7.67378591  ,    3.08514461)),
                Atom('C',     ( -2.73159414  ,    7.72480354  ,    2.83104329)),
                Atom('C',     (  0.74286011  ,    8.90142974  ,    2.88113091)),
                Atom('C',     ( -0.71708870  ,    8.90098800  ,    2.89139023)),
                Atom('C',     (  3.01722325  ,    9.10403236  ,    2.50394308)),
                Atom('C',     ( -2.99383377  ,    9.10106276  ,    2.53459289)),
                Atom('C',     (  1.78837097  ,    9.81630231  ,    2.56947759)),
                Atom('C',     ( -1.76426349  ,    9.81371458  ,    2.58210788)),
                Atom('H',     (  1.62566223  ,  -10.87066110  ,    2.27861876)),
                Atom('H',     ( -1.60380764  ,  -10.87166110  ,    2.28304045)),
                Atom('H',     (  4.02277624  ,   -9.50999923  ,    2.25199705)),
                Atom('H',     ( -4.00055744  ,   -9.51228588  ,    2.26946441)),
                Atom('H',     (  5.66556712  ,   -6.61548780  ,    2.17052051)),
                Atom('H',     ( -5.64410352  ,   -6.61516338  ,    2.18068081)),
                Atom('H',     (  5.64602121  ,   -3.92589328  ,    2.12451805)),
                Atom('H',     ( -5.62540919  ,   -3.92673373  ,    2.13957406)),
                Atom('H',     (  4.05966638  ,   -1.08783008  ,    2.39518664)),
                Atom('H',     ( -4.03851983  ,   -1.08684485  ,    2.41686866)),
                Atom('H',     (  4.05631970  ,    1.10327307  ,    2.37924282)),
                Atom('H',     ( -4.03830580  ,    1.10407002  ,    2.43133135)),
                Atom('H',     (  5.63871964  ,    3.94524354  ,    2.10781097)),
                Atom('H',     ( -5.60676114  ,    3.94571212  ,    2.12974409)),
                Atom('H',     (  5.66024386  ,    6.63456418  ,    2.18921504)),
                Atom('H',     ( -5.62659364  ,    6.63295294  ,    2.19763034)),
                Atom('H',     (  4.01888389  ,    9.52661693  ,    2.31748686)),
                Atom('H',     ( -3.99667017  ,    9.52289349  ,    2.35401589)),
                Atom('H',     (  1.62672551  ,   10.88526357  ,    2.36120645)),
                Atom('H',     ( -1.60326519  ,   10.88022155  ,    2.36002030)),
                ])
        Molecule.__init__(self, atoms, name=name, potential_strength=potential_strength)

class GasRelaxedDimerNitrogenNanographene(Molecule):
    def __init__(self, name=DEFAULT):
        atoms = ASEAtoms([
                Atom('H',(      -10.08678029  ,   -1.58755243  ,    2.43082122)),
                Atom('H',(      -10.08711885  ,    1.58797155  ,    2.42958679)),
                Atom('C',(       -9.20981715  ,   -1.74162628  ,    1.78777565)),
                Atom('C',(       -9.21031790  ,    1.74183622  ,    1.78629481)),
                Atom('H',(       -8.78359051  ,   -3.94791946  ,    2.02806854)),
                Atom('H',(       -8.78467291  ,    3.94840677  ,    2.02497554)),
                Atom('C',(       -8.53174797  ,   -0.73130695  ,    1.08421925)),
                Atom('C',(       -8.53199625  ,    0.73117228  ,    1.08351944)),
                Atom('C',(       -8.52507107  ,   -2.97995512  ,    1.57813073)),
                Atom('C',(       -8.52594547  ,    2.98019533  ,    1.57569525)),
                Atom('N',(       -7.47847820  ,   -1.37854057  ,    0.42287361)),
                Atom('N',(       -7.47895204  ,    1.37819024  ,    0.42156276)),
                Atom('C',(       -7.41913100  ,   -2.74253028  ,    0.74402079)),
                Atom('C',(       -7.41990590  ,    2.74243284  ,    0.74184318)),
                Atom('C',(       -6.45190719  ,   -0.70170751  ,   -0.20666777)),
                Atom('C',(       -6.45208334  ,    0.70109249  ,   -0.20718023)),
                Atom('C',(       -6.21205276  ,   -3.47109465  ,    0.35937178)),
                Atom('C',(       -6.21287928  ,    3.47097728  ,    0.35704777)),
                Atom('H',(       -6.13302028  ,   -5.53349896  ,    1.20456473)),
                Atom('H',(       -6.13468201  ,    5.53427221  ,    1.20020864)),
                Atom('C',(       -5.63529946  ,   -4.71740441  ,    0.66346935)),
                Atom('C',(       -5.63660226  ,    4.71781405  ,    0.65996126)),
                Atom('C',(       -5.29637102  ,   -1.40131483  ,   -0.58238666)),
                Atom('C',(       -5.29661349  ,    1.40068774  ,   -0.58310045)),
                Atom('N',(       -5.21425995  ,   -2.75285744  ,   -0.31380161)),
                Atom('N',(       -5.21473669  ,    2.75235417  ,   -0.31515436)),
                Atom('C',(       -4.28027194  ,   -4.71510704  ,    0.20611012)),
                Atom('C',(       -4.28153174  ,    4.71552772  ,    0.20268400)),
                Atom('C',(       -4.13966686  ,   -0.70025678  ,   -0.95947066)),
                Atom('C',(       -4.13980236  ,    0.69971551  ,   -0.95990099)),
                Atom('C',(       -4.01464116  ,   -3.46735446  ,   -0.38508592)),
                Atom('C',(       -4.01545998  ,    3.46723714  ,   -0.38719862)),
                Atom('H',(       -3.55135307  ,   -5.52671980  ,    0.33585814)),
                Atom('H',(       -3.55289295  ,    5.52756032  ,    0.33148681)),
                Atom('N',(       -2.93807862  ,   -1.36667389  ,   -1.06981452)),
                Atom('N',(       -2.93842699  ,    1.36646040  ,   -1.07088111)),
                Atom('C',(       -2.82500947  ,   -2.73725362  ,   -0.80795816)),
                Atom('C',(       -2.82573180  ,    2.73717961  ,   -0.80969219)),
                Atom('C',(       -1.68423638  ,   -0.73546734  ,   -1.17984354)),
                Atom('C',(       -1.68437297  ,    0.73551688  ,   -1.18021466)),
                Atom('C',(       -1.45994833  ,   -3.00628059  ,   -0.83361377)),
                Atom('C',(       -1.46078670  ,    3.00659110  ,   -0.83527910)),
                Atom('H',(       -1.02382420  ,   -3.99488469  ,   -0.65033310)),
                Atom('H',(       -1.02509820  ,    3.99551284  ,   -0.65270129)),
                Atom('C',(       -0.73067902  ,   -1.78237614  ,   -1.05857019)),
                Atom('C',(       -0.73111490  ,    1.78275747  ,   -1.05913364)),
                Atom('C',(        0.73135651  ,   -1.78211617  ,   -1.05911990)),
                Atom('C',(        0.73091160  ,    1.78299580  ,   -1.05857514)),
                Atom('H',(        1.02538624  ,   -3.99485928  ,   -0.65264596)),
                Atom('H',(        1.02409389  ,    3.99548799  ,   -0.65020614)),
                Atom('C',(        1.46105594  ,   -3.00593104  ,   -0.83527080)),
                Atom('C',(        1.46017886  ,    3.00689071  ,   -0.83356390)),
                Atom('C',(        1.68462406  ,   -0.73487147  ,   -1.18025517)),
                Atom('C',(        1.68447238  ,    0.73609933  ,   -1.17982830)),
                Atom('C',(        2.82600233  ,   -2.73650419  ,   -0.80977367)),
                Atom('C',(        2.82524130  ,    2.73785349  ,   -0.80786879)),
                Atom('N',(        2.93871748  ,   -1.36573977  ,   -1.07103077)),
                Atom('N',(        2.93832604  ,    1.36731401  ,   -1.06975648)),
                Atom('H',(        3.55305929  ,   -5.52685128  ,    0.33156725)),
                Atom('H',(        3.55170698  ,    5.52721851  ,    0.33597396)),
                Atom('C',(        4.01572451  ,   -3.46660958  ,   -0.38730914)),
                Atom('C',(        4.01488454  ,    3.46787595  ,   -0.38496789)),
                Atom('C',(        4.14009494  ,   -0.69910190  ,   -0.96000493)),
                Atom('C',(        4.13991441  ,    0.70086051  ,   -0.95948490)),
                Atom('C',(        4.28177205  ,   -4.71488892  ,    0.20263069)),
                Atom('C',(        4.28057093  ,    4.71559618  ,    0.20623210)),
                Atom('N',(        5.21505056  ,   -2.75178511  ,   -0.31547721)),
                Atom('N',(        5.21445004  ,    2.75335256  ,   -0.31361471)),
                Atom('C',(        5.29694924  ,   -1.40010051  ,   -0.58327526)),
                Atom('C',(        5.29660321  ,    1.40184956  ,   -0.58235605)),
                Atom('C',(        5.63689500  ,   -4.71722480  ,    0.65979163)),
                Atom('C',(        5.63556467  ,    4.71784394  ,    0.66363200)),
                Atom('H',(        6.13498380  ,   -5.53363590  ,    1.20012043)),
                Atom('H',(        6.13330851  ,    5.53390597  ,    1.20472088)),
                Atom('C',(        6.21323085  ,   -3.47042973  ,    0.35673972)),
                Atom('C',(        6.21226947  ,    3.47154928  ,    0.35953668)),
                Atom('C',(        6.45245232  ,   -0.70054626  ,   -0.20738831)),
                Atom('C',(        6.45219142  ,    0.70225437  ,   -0.20673105)),
                Atom('C',(        7.42033304  ,   -2.74192196  ,    0.74144968)),
                Atom('C',(        7.41938187  ,    2.74304183  ,    0.74411224)),
                Atom('N',(        7.47951051  ,   -1.37769704  ,    0.42121916)),
                Atom('N',(        7.47872898  ,    1.37909587  ,    0.42289036)),
                Atom('C',(        8.52634266  ,   -2.97972865  ,    1.57533904)),
                Atom('C',(        8.52535742  ,    2.98043973  ,    1.57817917)),
                Atom('C',(        8.53243320  ,   -0.73066473  ,    1.08324777)),
                Atom('C',(        8.53207936  ,    0.73182927  ,    1.08408511)),
                Atom('H',(        8.78502117  ,   -3.94797710  ,    2.02458583)),
                Atom('H',(        8.78386819  ,    3.94841451  ,    2.02808935)),
                Atom('C',(        9.21070867  ,   -1.74136380  ,    1.78601697)),
                Atom('C',(        9.21015616  ,    1.74212031  ,    1.78768876)),
                Atom('H',(       10.08747739  ,   -1.58750131  ,    2.42934988)),
                Atom('H',(       10.08721515  ,    1.58812194  ,    2.43063007)),
        ])
        atoms.positions[:, 2] = -atoms.positions[:, 2]
        Molecule.__init__(self, atoms, name=name, potential_strength=0.0)


class NPDiegoFlake(PolyaromaticHydroCarbon):
    def __init__(self, name=DEFAULT, parameters=DEFAULT):
        indices = (
                (3, 2),
                (0, 1), (1, 1), (2, 1), (3, 1), (4, 1),
                (0, 0), (1, 0), (2, 0), (3, 0),
                (-1, -1), (0,-1), (1,-1), (2,-1), (3,-1),
                (1,-2),
                )
        PolyaromaticHydroCarbon.__init__(self, indices, name=name, parameters=parameters)


class BuckledNitrogenNanographene(Molecule):
    def __init__(self, name=DEFAULT, potential_strength=1.0):
        atoms = ASEAtoms([
            Atom('H', ( -9.70488000, -1.48660000,  2.59690000,)),
            Atom('H', ( -9.70498000,  1.48725000,  2.59541000,)),
            Atom('C', ( -8.95536000, -1.68299000,  1.84816000,)),
            Atom('C', ( -8.95492000,  1.68335000,  1.84697000,)),
            Atom('H', ( -8.44289000, -3.76838000,  2.21082000,)),
            Atom('H', ( -8.44407000,  3.76845000,  2.20858000,)),
            Atom('C', ( -8.40666000, -0.67770000,  0.94764000,)),
            Atom('C', ( -8.40707000,  0.67808000,  0.94714000,)),
            Atom('C', ( -8.30499000, -2.85945000,  1.64881000,)),
            Atom('C', ( -8.30544000,  2.85898000,  1.64650000,)),
            Atom('N', ( -7.54193000, -1.39031000,  0.10250000,)),
            Atom('N', ( -7.54168000,  1.39027000,  0.10079000,)),
            Atom('C', ( -7.30079000, -2.67695000,  0.61012000,)),
            Atom('C', ( -7.30058000,  2.67596000,  0.60784000,)),
            Atom('C', ( -6.49679000, -0.69795000, -0.57706000,)),
            Atom('C', ( -6.49746000,  0.69689000, -0.57752000,)),
            Atom('C', ( -6.17674000, -3.35144000,  0.26669000,)),
            Atom('C', ( -6.17721000,  3.35126000,  0.26405000,)),
            Atom('H', ( -5.97651000, -5.25725000,  1.44424000,)),
            Atom('H', ( -5.97762000,  5.25743000,  1.44041000,)),
            Atom('C', ( -5.51359000, -4.53838000,  0.78772000,)),
            Atom('C', ( -5.51496000,  4.53844000,  0.78443000,)),
            Atom('C', ( -5.33558000, -1.39033000, -0.92942000,)),
            Atom('C', ( -5.33537000,  1.38924000, -0.93111000,)),
            Atom('N', ( -5.23638000, -2.77225000, -0.59912000,)),
            Atom('N', ( -5.23761000,  2.77199000, -0.60112000,)),
            Atom('C', ( -4.21555000, -4.53422000,  0.38479000,)),
            Atom('C', ( -4.21727000,  4.53462000,  0.38170000,)),
            Atom('C', ( -4.17236000, -0.69413000, -1.28712000,)),
            Atom('C', ( -4.17234000,  0.69367000, -1.28741000,)),
            Atom('C', ( -3.97180000, -3.33952000, -0.41239000,)),
            Atom('C', ( -3.97234000,  3.33917000, -0.41443000,)),
            Atom('H', ( -3.45922000, -5.24773000,  0.66513000,)),
            Atom('H', ( -3.46015000,  5.24890000,  0.66075000,)),
            Atom('N', ( -2.92597000, -1.37925000, -1.31938000,)),
            Atom('N', ( -2.92673000,  1.37835000, -1.32051000,)),
            Atom('C', ( -2.85625000, -2.65810000, -0.76526000,)),
            Atom('C', ( -2.85669000,  2.65780000, -0.76762000,)),
            Atom('C', ( -1.70121000, -0.68196000, -1.16652000,)),
            Atom('C', ( -1.70127000,  0.68181000, -1.16722000,)),
            Atom('C', ( -1.44920000, -2.86997000, -0.52769000,)),
            Atom('C', ( -1.45071000,  2.86954000, -0.52951000,)),
            Atom('H', ( -1.08129000, -3.83489000, -0.22133000,)),
            Atom('H', ( -1.08153000,  3.83507000, -0.22387000,)),
            Atom('C', ( -0.72696000, -1.73418000, -0.78991000,)),
            Atom('C', ( -0.72795000,  1.73437000, -0.79061000,)),
            Atom('C', (  0.72750000, -1.73488000, -0.79110000,)),
            Atom('C', (  0.72757000,  1.73465000, -0.79084000,)),
            Atom('H', (  1.08192000, -3.83512000, -0.22346000,)),
            Atom('H', (  1.08069000,  3.83400000, -0.22097000,)),
            Atom('C', (  1.44980000, -2.86989000, -0.52902000,)),
            Atom('C', (  1.44932000,  2.86965000, -0.52785000,)),
            Atom('C', (  1.70130000, -0.68224000, -1.16676000,)),
            Atom('C', (  1.70130000,  0.68254000, -1.16649000,)),
            Atom('C', (  2.85666000, -2.65815000, -0.76708000,)),
            Atom('C', (  2.85625000,  2.65784000, -0.76545000,)),
            Atom('N', (  2.92614000, -1.37845000, -1.31958000,)),
            Atom('N', (  2.92639000,  1.37916000, -1.31873000,)),
            Atom('H', (  3.45989000, -5.24846000,  0.66154000,)),
            Atom('H', (  3.45904000,  5.24836000,  0.66515000,)),
            Atom('C', (  3.97240000, -3.33980000, -0.41501000,)),
            Atom('C', (  3.97196000,  3.34001000, -0.41208000,)),
            Atom('C', (  4.17233000, -0.69316000, -1.28768000,)),
            Atom('C', (  4.17236000,  0.69466000, -1.28698000,)),
            Atom('C', (  4.21717000, -4.53424000,  0.38139000,)),
            Atom('C', (  4.21547000,  4.53377000,  0.38532000,)),
            Atom('N', (  5.23747000, -2.77200000, -0.60147000,)),
            Atom('N', (  5.23627000,  2.77234000, -0.59947000,)),
            Atom('C', (  5.33549000, -1.38982000, -0.93070000,)),
            Atom('C', (  5.33578000,  1.39083000, -0.92942000,)),
            Atom('C', (  5.51479000, -4.53883000,  0.78397000,)),
            Atom('C', (  5.51354000,  4.53917000,  0.78765000,)),
            Atom('H', (  5.97782000, -5.25786000,  1.44044000,)),
            Atom('H', (  5.97679000,  5.25701000,  1.44461000,)),
            Atom('C', (  6.17707000, -3.35079000,  0.26395000,)),
            Atom('C', (  6.17661000,  3.35104000,  0.26634000,)),
            Atom('C', (  6.49774000, -0.69671000, -0.57706000,)),
            Atom('C', (  6.49704000,  0.69716000, -0.57650000,)),
            Atom('C', (  7.30137000, -2.67624000,  0.60842000,)),
            Atom('C', (  7.30062000,  2.67682000,  0.61014000,)),
            Atom('N', (  7.54171000, -1.38999000,  0.10111000,)),
            Atom('N', (  7.54199000,  1.39066000,  0.10239000,)),
            Atom('C', (  8.30523000, -2.85903000,  1.64650000,)),
            Atom('C', (  8.30481000,  2.85949000,  1.64818000,)),
            Atom('C', (  8.40679000, -0.67727000,  0.94734000,)),
            Atom('C', (  8.40634000,  0.67753000,  0.94786000,)),
            Atom('H', (  8.44460000, -3.76831000,  2.20780000,)),
            Atom('H', (  8.44342000,  3.76764000,  2.21059000,)),
            Atom('C', (  8.95517000, -1.68338000,  1.84616000,)),
            Atom('C', (  8.95564000,  1.68304000,  1.84797000,)),
            Atom('H', (  9.70519000, -1.48765000,  2.59526000,)),
            Atom('H', (  9.70515000,  1.48727000,  2.59675000,)),
            ])
        translate = -np.array([0, 0, atoms.positions[:, 2].min()])
        atoms.translate(translate)
        Molecule.__init__(self, atoms, name=name, potential_strength=potential_strength)
